<?
        require "common.php";
//        $_debug = 1;
        
        $srv = load_lines(262144);
        $lst = load_lines(1024000, "lst", "lst_data");
        
        
        
        $mode = $_REQUEST["mode"];
        $facing = $_REQUEST["facing"];
        $marksize = $_REQUEST["marksize"];
        $textsize = $_REQUEST["textsize"];

        if(!is_numeric($facing))
                $facing = 0;

        $facing_rad = deg2rad($facing);
        
        
	$coord = array(); $minc = array(1000000000, 1000000000, 1000000000);
	foreach($lst as $line)
	{
		list($prefix, $name, $x, $y, $z) = explode("|", trim(str_replace("\t", "|", $line)));
		$prefix = strtolower($prefix);
		$name = strtolower($name);
		if(is_numeric($x) && is_numeric($y) && is_numeric($z))
		{
		        $xp = $x * cos($facing_rad) - $y * sin($facing_rad);
		        $yp = $x * sin($facing_rad) + $y * cos($facing_rad);
		        $q = array($xp, $yp, $z, $name);
			$gcoord[substr($prefix, 0, 8) . ":" . $name] = $q;
			for($i = 0; $i<3; $i++)
			        $minc[$i] = min($minc[$i], $q[$i]);
                }
	}
	
	$legs = array();
	$legindex = array();
	$year = "";
	$prefix = "";
	foreach($srv as $line)
	{
		$line = trim($line);
		list($kw, $da) = explode(" ", strtr($line, array("\t" => " ")), 2);
		if($kw == "#date") $year = substr($da, 0, 4);
		if(strtolower($kw) == "#prefix")
			$prefix = substr(strtolower(trim($da)), 0, 8);
		
		list($from, $to, $a, $b, $c) = explode("\t", $line);
		if($from == "-" || $to == "-") continue;
		$a = trim($a);
		$b = trim($b);
		$c = trim($c);
		$from = trim(strtolower($from));
		$to = trim(strtolower($to));
		
		if(strpos($from, ":") === FALSE) $from = $prefix . ":" . $from;
		if(strpos($to, ":") === FALSE) $to = $prefix . ":" . $to;
		
		
		if(isset($legindex[$from][$to]) || isset($legindex[$to][$from])) continue;
		$legindex[$from][$to] = true;
		
		if(is_numeric($a) && is_numeric($b) && is_numeric($c))
			$legs[$year][] = array(trim($from), trim($to));
	}
	
	if($_debug)
	{
		header("Content-type: text/plain; charset=utf-8");
        	print_r($gcoord);
        	print_r($legs);
//        	exit;
	}
	foreach($legs as $year => $year_legs)
	{
//		$coord[$year][0] = $gcoord[0];
		foreach($year_legs as $leg)
		{
			$coord[$year][$leg[0]] = $gcoord[$leg[0]];
			$coord[$year][$leg[1]] = $gcoord[$leg[1]];
		}
	}
	if(!$_debug)
	{                                  
                header("Content-type: image/svg+xml; charset=utf-8");
                header("Content-disposition: attachment; filename=" . substr(md5(uniqid()), 0, 8) . ".svg");
	}
	else
		header("Content-type: text/plain");	
	
	$c1 = $mode{0} - 1 ;
	$c2 = $mode{1} - 1 ;
	
	function go_layer($year, $legs, $coord, $c1, $c2, $ms, $ts)
	{
		global $gid, $minc;
		echo "    <g\n       id=\"y$year\">\n"; $gid++;
		echo "      <g\n         id=\"g$gid\"\n         style=\"stroke:#000000;stroke-linecap:butt\">\n";
		foreach($legs as $leg)
		{
			list($a, $b) = $leg;
		
			if(!isset($coord[$a])) continue;
			if(!isset($coord[$b])) continue;
		
			$p1 = $coord[$a];
			$p2 = $coord[$b];
		
			$x1 = $p1[$c1] - $minc[$c1]; $y1 = -($p1[$c2] - $minc[$c2]);
			$x2 = $p2[$c1] - $minc[$c1]; $y2 = -($p2[$c2] - $minc[$c2]);
		
			echo sprintf("        <line\n           x1=\"%.2fmm\"\n           y1=\"%.2fmm\"\n           x2=\"%.2fmm\"\n           y2=\"%.2fmm\"\n           stroke-width=\"0.1\"\n           id=\"line%d\"\n           style=\"stroke-width:0.1\" />\n", 
					$x1, $y1, $x2, $y2, ++$gid);
				
		}
		echo "      </g>\n";
		if($ms)
		{
			$gid++;	
			echo "      <g\n         id=\"g$gid\"\n         style=\"stroke:#000000;stroke-linecap:butt\">\n";
			foreach($coord as $id => $pt)
			{
				if(!$id) continue;
				$x = $pt[$c1] - $minc[$c1]; $y = -($pt[$c2] - $minc[$c2]);

				echo sprintf("        <line\n           x1=\"%.2fmm\"\n           y1=\"%.2fmm\"\n           x2=\"%.2fmm\"\n           y2=\"%.2fmm\"\n           stroke-width=\"0.1\"\n           id=\"line%d\"\n           style=\"stroke-width:0.2\" />\n", 
						$x - $ms, $y, $x + $ms, $y, ++$gid);

				echo sprintf("        <line\n           x1=\"%.2fmm\"\n           y1=\"%.2fmm\"\n           x2=\"%.2fmm\"\n           y2=\"%.2fmm\"\n           stroke-width=\"0.1\"\n           id=\"line%d\"\n           style=\"stroke-width:0.2\" />\n", 
						$x, $y - $ms, $x, $y + $ms, ++$gid);
			}
			echo "      </g>\n";
		}


		$gid++;
		echo "      <g\n         id=\"g$gid\"\n         style=\"stroke:#000000;stroke-linecap:butt\">\n";
		foreach($coord as $id => $pt)
		{
			if(!$id) continue;
			$x = $pt[$c1] - $minc[$c1]; $y = -($pt[$c2] - $minc[$c2]);	
			$text = $pt[3];

			echo sprintf("        <text\n               x=\"%.2fmm\"  y=\"%.2fmm\"      id=\"text%d\"\n           style=\"font-size:{$ts}pt;fill:#000000;stroke:none;font-family:'Helvetica,sans-serif'\">%s</text>",
				 $x, $y, ++$gid, $text) . "\n";
		}	

		echo "      </g>\n";
		echo "    </g>\n";
	}

	echo '<?xml version="1.0" encoding="UTF-8" standalone="no"?>' . "\n";
	echo '<!-- Created with a toolset by Mateusz Golicz (http://walls.nocek.pl/) -->' . "\n\n";
	echo '<svg ' . "\n";
	echo '   xmlns:svg="http://www.w3.org/2000/svg" ' . "\n";
	echo '   xmlns="http://www.w3.org/2000/svg" ' . "\n";
	echo '   version="1.0" ' . "\n";
	echo '   width="210mm" ' . "\n";
	echo '   height="297mm" ' . "\n";
	echo '   id="body">' . "\n";
	echo '  <title ' . "\n";
	echo '     id="title3">SVG drawing</title>' . "\n";
	echo '  <defs ' . "\n";
	echo '     id="defs7606" />' . "\n";
	echo '  <g ' . "\n";
	echo '     id="g5">' . "\n";
	
	$gid = 10;

	foreach($legs as $year => $year_legs)
		go_layer($year, $year_legs, $coord[$year], $c1, $c2, $marksize, $textsize);

	echo "  </g>\n";
	echo "</svg>\n";
	
?>